# WARNING - Generated by {fusen} from dev/flat_full.Rmd: do not edit by hand

test_that("getInput2mvrnorm returns the correct list", {
  list_var <- init_variable()
  input <- getInput2mvrnorm(list_var)
  expect_is(input, "list")
  expect_true("mu" %in% names(input))
  expect_true("covMatrix" %in% names(input))
})


test_that("fillInCovarMatrice returns the correct matrix", {
  covarMat <- matrix(0, nrow = 3, ncol = 3)
  colnames(covarMat) <- c("label_varA", "label_varB", "label_varC")
  rownames(covarMat) <- c("label_varA", "label_varB", "label_varC")
  covarValue <- data.frame("varA.varB" = 18)
  matrice <- fillInCovarMatrice(covarMatrice = covarMat, covar = covarValue)
  
  expected_matrice <- matrix(0, nrow = 3, ncol = 3)
  colnames(expected_matrice) <- c("label_varA", "label_varB", "label_varC")
  rownames(expected_matrice) <- c("label_varA", "label_varB", "label_varC")
  expected_matrice["label_varA", "label_varB"] <- 18
  expected_matrice["label_varB", "label_varA"] <- 18
  expect_identical(matrice, expected_matrice)
})

test_that("getCovarianceMatrix returns the correct covariance matrix", {
  vector_sd <- c(1,2, 3)
  names(vector_sd) <- c("varA", "varB", "varC")
  vector_covar <- c(8, 12, 24)
  names(vector_covar) <- c("varA.varB", "varA.varC", "varB.varC")
  covMatrix <- getCovarianceMatrix(vector_sd, vector_covar)
  
  expect_is(covMatrix, "matrix")
  expect_equal(dim(covMatrix), c(3, 3))
  expected_matrix <- matrix(c(1,8,12,8,4,24, 12,24,9), nrow = 3,  byrow = T)
  rownames(expected_matrix) <- c("label_varA", "label_varB", "label_varC")
  colnames(expected_matrix) <- c("label_varA", "label_varB", "label_varC")
  expect_equal(expected_matrix, covMatrix)
})

test_that("getGeneMetadata returns the correct metadata", {
  list_var <- init_variable()
  n_genes <- 10
  metadata <- getGeneMetadata(list_var, n_genes)
  expect_is(metadata, "data.frame")
  expect_equal(colnames(metadata), c("geneID", paste("label", (attributes(list_var)$names), sep ="_")))
  expect_equal(nrow(metadata), n_genes * list_var$myVariable$level)
})

test_that("getDataFromMvrnorm returns the correct data", {
  list_var <- init_variable(name = "varA", mu = 1, sd = 4, level = 3) %>% init_variable("varB", mu = 2, sd = 1, level = 2)
  input <- getInput2mvrnorm(list_var)
  n_genes <- 10
  n_samplings <- n_genes * (list_var$varA$level ) * (list_var$varB$level )
  data <- getDataFromMvrnorm(list_var, input, n_genes)
  expect_is(data, "list")
  expect_equal(length(data), 1)
  expect_is(data[[1]], "data.frame")
  expect_equal(nrow(data[[1]]), n_samplings)
  
})

test_that("getDataFromMvrnomr returns empty list",{
  list_var <- init_variable()
  input <- getInput2mvrnorm(list_var)
  n_genes <- 10
  n_samplings <- n_genes * (list_var$varA$level ) * (list_var$varB$level )
  data <- getDataFromMvrnorm(list_var, input, n_genes)
  expect_is(data, "list")
  expect_equal(data, list())
})

test_that("samplingFromMvrnorm returns the correct sampling", {
  n_samplings <- 100
  l_mu <- c(1, 2)
  matx_cov <- matrix(c(1, 0.5, 0.5, 1), ncol = 2)
  sampling <- samplingFromMvrnorm(n_samplings, l_mu, matx_cov)
  
  expect_is(sampling, "matrix")
  expect_equal(dim(sampling), c(n_samplings, length(l_mu)))
})


