# WARNING - Generated by {fusen} from dev/flat_full.Rmd: do not edit by hand




test_that("extract_tmbDispersion function extracts dispersion correctly", {
   N_GENES = 100
  MAX_REPLICATES = 5
  MIN_REPLICATES = 5
  input_var_list <- init_variable(name = "varA", mu = 10, sd = 0.1, level = 3)
  mock_data <- mock_rnaseq(input_var_list, N_GENES,
                         min_replicates = MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  data2fit <- prepareData2fit(countMatrix = mock_data$counts, metadata =  mock_data$metadata, normalization = 'MRN')
  l_res <- fitModelParallel(formula = kij ~ varA,
                          data = data2fit, group_by = "geneID",
                          family = glmmTMB::nbinom2(link = "log"), n.cores = 1)
  extracted_disp <- extract_tmbDispersion(l_res)
  expect_identical(colnames(extracted_disp), c("estimate", "ID"))
})

test_that("extract_ddsDispersion function extracts dispersion correctly", {
  N_GENES = 100
  MAX_REPLICATES = 5
  MIN_REPLICATES = 5
  input_var_list <- init_variable(name = "varA", mu = 10, sd = 0.1, level = 3)
  mock_data <- mock_rnaseq(input_var_list, N_GENES,
                         min_replicates = MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  dds <- DESeq2::DESeqDataSetFromMatrix(
      countData = round(mock_data$counts),
      colData = mock_data$metadata,
      design = ~ varA)
  dds <- DESeq2::DESeq(dds, quiet = TRUE)
  deseq_wrapped = wrap_dds(dds, 2, "greaterAbs")
  
  extracted_disp <- extract_ddsDispersion(deseq_wrapped)
  expect_identical(colnames(extracted_disp), c("estimate", "ID"))
})

test_that("getDispersionComparison function works correctly", {
   N_GENES = 100
  MAX_REPLICATES = 5
  MIN_REPLICATES = 5
  input_var_list <- init_variable(name = "varA", mu = 10, sd = 0.1, level = 3)
  mock_data <- mock_rnaseq(input_var_list, N_GENES,
                         min_replicates = MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  data2fit <- prepareData2fit(countMatrix = mock_data$counts, metadata =  mock_data$metadata, normalization = 'MRN')
  l_res <- fitModelParallel(formula = kij ~ varA,
                          data = data2fit, group_by = "geneID",
                          family = glmmTMB::nbinom2(link = "log"), n.cores = 1)
  
  tmb_disp_inferred <- extract_tmbDispersion(l_res)
    
  comparison <- getDispersionComparison(tmb_disp_inferred, mock_data$groundTruth$gene_dispersion)
  expect_identical(colnames(comparison), c("actual",  "ID", "estimate",  "term","description"))
})


