# WARNING - Generated by {fusen} from dev/flat_full.Rmd: do not edit by hand


test_that("extract_fixed_effect returns the correct results for glmmTMB models", {
  data(iris)
  # Créer un modèle glmmTMB avec les données iris (exemple)
  model <- glmmTMB::glmmTMB(Sepal.Length ~ Sepal.Width + Petal.Length + (1|Species), data = iris)
  
  # Appeler la fonction extract_fixed_effect sur le modèle
  result <- extract_fixed_effect(model)
  
  # Check les résultats attendus
  expect_s3_class(result, "data.frame")
  expect_equal(result$effect, c("fixed", "fixed", "fixed"))
  expect_equal(result$component , c("cond", "cond", "cond"))
  expect_equal(result$term , c("(Intercept)", "Sepal.Width", "Petal.Length"))
  
})


test_that("getTidyGlmmTMB returns the correct results for glmmTMB models", {
  data(iris)
  # Créer un modèle glmmTMB avec les données iris (exemple)
  model <- glmmTMB::glmmTMB(Sepal.Length ~ Sepal.Width + Petal.Length, data = iris)
  tidy_summary <- getTidyGlmmTMB(glm_TMB = model, ID = "Model1")
  
  # Check les résultats attendus
  expect_s3_class(tidy_summary, "data.frame")
  expect_equal(tidy_summary$effect, c("fixed", "fixed", "fixed"))
  expect_equal(tidy_summary$component , c("cond", "cond", "cond"))
  expect_equal(tidy_summary$term , c("(Intercept)", "Sepal.Width", "Petal.Length"))
  expect_equal(tidy_summary$ID , c("Model1", "Model1", "Model1"))

  #MODEL == NULL
  tidy_summary <- getTidyGlmmTMB(glm_TMB = NULL, ID = "Model1")
  expect_equal(tidy_summary, NULL)
})


test_that("build_missingColumn_with_na returns the correct results", {
  df <- data.frame(effect = "fixed", term = "Sepal.Length", estimate = 0.7)
  df_with_na <- build_missingColumn_with_na(df)
  expected_df <- data.frame(effect = "fixed",
                            term = "Sepal.Length",
                            estimate = 0.7,
                            component = NA,
                            group = NA,
                            std.error = NA,
                            statistic = NA,
                            p.value  = NA)
    
  expect_equal(df_with_na, expected_df)
})



test_that("correlation_matrix_2df returns expected output",{

  mat <- matrix(c(1, 0.7, 0.5, 0.7, 1, 0.3, 0.5, 0.3, 1), nrow = 3, dimnames = list(c("A", "B", "C"), c("A", "B", "C")))
  df_corr <- correlation_matrix_2df(mat)
  df_expected <- data.frame(estimate = c(0.7, 0.5, 0.3),
                            term = c("cor__A.B", "cor__A.C", "cor__B.C"))
  expect_equal(df_corr, df_expected)
})



test_that("wrapper_var_cor returns expected output",{
  data(iris)
  model <- glmmTMB::glmmTMB(Sepal.Length ~ Sepal.Width + Petal.Length + (1|Species), data = iris, family = gaussian)
  var_cor <- summary(model)$varcor$cond
  ran_pars_df <- wrapper_var_cor(var_cor, "Species")
  expected_l = list(data.frame(estimate = 0.4978083, term = "sd_(Intercept)", 
                               component = "Species", effect = "ran_pars", group = "Species"))
  expect_equal(ran_pars_df , expected_l, tolerance = 0.0000001) 
})


test_that("extract_ran_pars returns expected output",{
  model <- glmmTMB::glmmTMB(Sepal.Length ~ Sepal.Width + Petal.Length + (1|Species), 
                            data = iris, family = gaussian)
  random_params <- extract_ran_pars(model)
  
  expected_df = data.frame(estimate = 0.4978083, term = "sd_(Intercept)", 
                               component = "cond", effect = "ran_pars", group = "Species")
  expect_equal(random_params , expected_df, tolerance = 0.0000001) 
})


test_that("renameColumns returns expected output",{
  df <- data.frame(Estimate = c(1.5, 2.0, 3.2),
                  Std..Error = c(0.1, 0.3, 0.2),
                  z.value = c(3.75, 6.67, 4.90),
                  Pr...z.. = c(0.001, 0.0001, 0.002))

  new_colnames <- c("estimate", "std.error", "statistic", "p.value")
  renamed_df <- renameColumns(df, old_names = c("Estimate", "Std..Error", "z.value", "Pr...z.."),
                               new_names = new_colnames)
  expect_equal(colnames(renamed_df),c("estimate", "std.error", "statistic", "p.value"))
  expect_equal(dim(renamed_df), dim(df))
})
    
test_that("tidy_tmb returns expected output",{
  model1 <- glmmTMB::glmmTMB(Sepal.Length ~ Sepal.Width + Petal.Length + (1 | Species), data = iris)
  model2 <- glmmTMB::glmmTMB(Petal.Length ~ Sepal.Length + Sepal.Width + (1 | Species), data = iris)
  model_list <- list(Model1 = model1, Model2 = model2)
  result <- tidy_tmb(model_list)
  expect_equal(unique(result$ID), c("Model1", "Model2"))
  expect_equal(unique(result$effect), c("fixed", "ran_pars"))
  expect_equal(unique(result$component), "cond")
  expect_equal(unique(result$term), c("(Intercept)", "Sepal.Width", "Petal.Length", "sd_(Intercept)", "Sepal.Length"))
  expect_true("estimate" %in% colnames(result))
  expect_true("std.error" %in% colnames(result))
  expect_true("statistic" %in% colnames(result))
  expect_true("p.value" %in% colnames(result))
  
  
  # zi component
  model2 <- glmmTMB::glmmTMB(Petal.Length ~ Sepal.Length + Sepal.Width + (1 | Species), data = iris, ziformula = ~1)
  model_list <- list(Model1 = model1, Model2 = model2)
  result_withZi <- tidy_tmb(model_list)
  expect_equal(dim(result_withZi)[1], dim(result)[1] + 1 )
  expect_equal(unique(result_withZi$component), c("cond", "zi"))

   ## unique obect in list 
  model <- glmmTMB::glmmTMB(Sepal.Length ~ Sepal.Width + Petal.Length + (1|Species), data = iris)
  result <- tidy_tmb(model)
  expect_true("effect" %in% colnames(result))
  expect_true("component" %in% colnames(result))
  expect_true("group" %in% colnames(result))
  expect_true("term" %in% colnames(result))
  expect_true("estimate" %in% colnames(result))
  expect_true("std.error" %in% colnames(result))
  expect_true("statistic" %in% colnames(result))
  expect_true("p.value" %in% colnames(result))
})
