# WARNING - Generated by {fusen} from dev/flat_full.Rmd: do not edit by hand



test_that("get_inference_dds returns a data frame with correct columns", {
  # Create a sample dds_full data frame
  N_GENES = 100
  MAX_REPLICATES = 5
  MIN_REPLICATES = 5
  ## --init variable
  input_var_list <- init_variable( name = "genotype", mu = 12, sd = 0.1, level = 3) %>%
                    init_variable(name = "environment", mu = c(0,1), NA , level = 2) 

  mock_data <- mock_rnaseq(input_var_list, N_GENES, MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  dds <- DESeq2::DESeqDataSetFromMatrix(mock_data$counts , mock_data$metadata, ~ genotype + environment)
  dds <- DESeq2::DESeq(dds, quiet = TRUE)
  dds_full <- S4Vectors::mcols(dds) %>% as.data.frame()
  
  # Call the function
  inference_results <- get_inference_dds(dds_full, lfcThreshold = 0.5, altHypothesis = "greater", correction_method = "BH")
  
  # Check if the returned object is a data frame
  expect_true(is.data.frame(inference_results))
  
  # Check if the data frame contains the correct columns
  expect_true("ID" %in% colnames(inference_results))
  expect_true("estimate" %in% colnames(inference_results))
  expect_true("std.error" %in% colnames(inference_results))
  expect_true("term" %in% colnames(inference_results))
  expect_true("effect" %in% colnames(inference_results))
  expect_true("statistic" %in% colnames(inference_results))
  expect_true("p.value" %in% colnames(inference_results))
  expect_true("p.adj" %in% colnames(inference_results))
})






test_that("getEstimate_df function works correctly", {
  
 # Create a sample dds_full data frame
  N_GENES = 100
  MAX_REPLICATES = 5
  MIN_REPLICATES = 5
  ## --init variable
  input_var_list <- init_variable( name = "genotype", mu = 12, sd = 0.1, level = 3) %>%
                    init_variable(name = "environment", mu = c(0,1), NA , level = 2) 

  mock_data <- mock_rnaseq(input_var_list, N_GENES, MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  dds <- DESeq2::DESeqDataSetFromMatrix(mock_data$counts , mock_data$metadata, ~ genotype + environment)
  dds <- DESeq2::DESeq(dds, quiet = TRUE)
  dds_full <- S4Vectors::mcols(dds) %>% as.data.frame()
  
  # Call the function
  estimate_df_long <- getEstimate_df(dds_full)
  
  # Check if the resulting data frame has the expected structure
  expect_true("ID" %in% colnames(estimate_df_long))
  expect_true("term" %in% colnames(estimate_df_long))
  expect_true("estimate" %in% colnames(estimate_df_long))
})



# Define a test context
test_that("getSE_df function works correctly", {
  
 # Create a sample dds_full data frame
  N_GENES = 100
  MAX_REPLICATES = 5
  MIN_REPLICATES = 5
  ## --init variable
  input_var_list <- init_variable( name = "genotype", mu = 12, sd = 0.1, level = 3) %>%
                    init_variable(name = "environment", mu = c(0,1), NA , level = 2) 

  mock_data <- mock_rnaseq(input_var_list, N_GENES, MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  dds <- DESeq2::DESeqDataSetFromMatrix(mock_data$counts , mock_data$metadata, ~ genotype + environment)
  dds <- DESeq2::DESeq(dds, quiet = TRUE)
  dds_full <- S4Vectors::mcols(dds) %>% as.data.frame()
  
  # Call the function
  SE_df_long <- getSE_df(dds_full)
  
  # Check if the resulting data frame has the expected structure
  expect_true("ID" %in% colnames(SE_df_long))
  expect_true("term" %in% colnames(SE_df_long))
  expect_true("std.error" %in% colnames(SE_df_long))
})


# Define a test context
test_that("wrapperDESeq2 function works correctly", {
  
 # Create a sample dds_full data frame
  N_GENES = 100
  MAX_REPLICATES = 5
  MIN_REPLICATES = 5
  ## --init variable
  input_var_list <- init_variable( name = "genotype", mu = 12, sd = 0.1, level = 3) %>%
                    init_variable(name = "environment", mu = c(0,1), NA , level = 2) 

  mock_data <- mock_rnaseq(input_var_list, N_GENES, MIN_REPLICATES, max_replicates = MAX_REPLICATES)
  dds <- DESeq2::DESeqDataSetFromMatrix(mock_data$counts , mock_data$metadata, ~ genotype + environment)
  dds <- DESeq2::DESeq(dds, quiet = TRUE)
  deseq2_wrapped <- wrap_dds(dds, 0.2, "greaterAbs")
  
  expect_true(is.list(deseq2_wrapped))
  
  # Check if the resulting data frame has the expected structure
  expect_true("ID" %in% colnames(deseq2_wrapped$fixEff))
  expect_true("term" %in% colnames(deseq2_wrapped$fixEff))
  expect_true("std.error" %in% colnames(deseq2_wrapped$fixEff))
  expect_true("estimate" %in% colnames(deseq2_wrapped$fixEff))
  expect_true("statistic" %in% colnames(deseq2_wrapped$fixEff))
  expect_true("p.value" %in% colnames(deseq2_wrapped$fixEff))
  expect_true("p.adj" %in% colnames(deseq2_wrapped$fixEff))

})


